
#include <iostream>
#include <fstream>
#include "huffmantree.h"
using namespace std;
using namespace Huffman;


int main(int argc, char** argv)
{
    if(argc > 2)
    {
        ifstream is(argv[1]);
        ofstream os(argv[2]);

        // construct tree
        HuffmanTree t;
        int numberofbytes = t.ConstructFromStream(is);
        is.close();
        is.clear();
        
        // store the tree in the target file
        t.SaveToStream(os);
        
        // store the number of bytes in the target file
        os.write(reinterpret_cast<const char *>(&numberofbytes), sizeof(numberofbytes));

        // store the content in the target file
        is.open(argv[1]);
        t.Encode(is, os);

        return 0;
    }
    else
    {
        cerr << "usage: " << argv[0] << " <srcfile> <dstfile>\n";
        return 1;
    }
}
