
#ifndef __SORTING_CPP
    #define __SORTING_CPP

    namespace Huffman
    {
        
        template<class T> inline void swap(T& x, T& y)
        {
            T z = x;
            x = y;
            y = z;
        }

        template<class T> void SelectionSort(std::vector<T>& array, int compare(T a, T b))
        {
            for(int i = 0; i < array.size(); i++)
            {
                int maxpos = i;
                for(int j = i+1; j < array.size(); j++)
                    if(compare(array[j], array[maxpos]) == 1)
                        maxpos=j;
                swap(array[i], array[maxpos]);
            }
        }

        template<class T> void InsertionSortOnce(std::vector<T>& array, int i, int compare(T a, T b))
        {
            T bak = array[i];
            int j;
            for(j = i; j > 0 && compare(array[j-1], bak) == -1; j--)
                array[j]=array[j-1];
            array[j] = bak;
        }

    }
    
#endif
