#include "huffmantree.h"
#include <iostream>
#include <fstream>
using namespace std;
using namespace Huffman;

int main(int argc, char** argv)
{
    if(argc > 1)
    {
        ifstream is(argv[1]);
        HuffmanTree t;
        
        // read tree from file
        t.LoadFromStream(is);
        
        // read number of bytes from file
        int numberofbytes;
        is.read(reinterpret_cast<char *>(&numberofbytes), sizeof(numberofbytes));
        
        if(argc > 2)
        {
            ofstream os(argv[2]);
            t.Decode(is, numberofbytes, os);
        }
        else
        {
            t.Decode(is, numberofbytes, cout);
        }
    
        return 0;
    }
    else
    {
        cerr << "usage: " << argv[0] << " <srcfile> <dstfile>\n";
        return 1;
    }
}
